<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryFormRef" :inline="true" label-width="80px">
      <el-form-item label="所屬用戶" prop="username">
        <el-input
            v-model="queryParams.username"
            placeholder="請輸入所屬用戶"
            clearable
            @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜尋</el-button>
        <el-button icon="Refresh" @click="resetQuery">重設</el-button>
      </el-form-item>
    </el-form>
    <el-table v-loading="loading" :data="callList">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="id" align="center" prop="id" />
      <el-table-column label="用戶ID" align="center" prop="userId" />
      <el-table-column label="所屬用戶" align="center" prop="userName" />
      <el-table-column label="電話號碼" align="center" prop="phoneNumber" />
      <el-table-column label="通話類型" align="center" prop="callType">
        <template #default="{ row }">
          <span>{{ callTypeText(row.callType) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="通話開始時間" align="center" prop="startTime" />
      <el-table-column label="通話時長" align="center" prop="duration" />
      <el-table-column label="通訊錄名稱" align="center" prop="contactName" />
      <el-table-column label="操作" align="center" width="140" class-name="small-padding fixed-width">
        <template #default="{ row }">
          <el-tooltip content="查看" placement="top">
            <el-button link type="primary" icon="View" @click.stop="handleView(row)"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>
    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    <el-dialog :title="title" v-model="open" width="600px" append-to-body>
      <el-form ref="formRef" :model="form"  label-width="80px">
        <el-form-item label="用戶id" prop="userId">
          <el-input v-model="form.userId" placeholder="請輸入用戶id" />
        </el-form-item>
        <el-form-item label="所屬用戶" prop="userName">
          <el-input v-model="form.userName" />
        </el-form-item>
        <el-form-item label="電話號碼" prop="phoneNumber">
          <el-input v-model="form.phoneNumber" placeholder="請輸入電話號碼" />
        </el-form-item>
        <el-form-item label="通話開始時間" prop="startTime">
          <el-input v-model="form.startTime" placeholder="請輸入通話開始時間" />
        </el-form-item>
        <el-form-item label="通話時長" prop="duration">
          <el-input v-model="form.duration" placeholder="請輸入通話時長" />
        </el-form-item>
        <el-form-item label="通訊錄名稱" prop="contactName">
          <el-input v-model="form.contactName" placeholder="請輸入通訊錄名稱" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup>
import {ref, reactive, getCurrentInstance, onMounted, nextTick} from 'vue'
import {getCallPageList} from '@/api/system/call.js'
const { proxy } = getCurrentInstance()
const { sys_show_hide, sys_normal_disable } = proxy.useDict("sys_show_hide", "sys_normal_disable")

const callList = ref([])
const total = ref(0)
const title = ref("")
const open = ref(false)
const form = ref({})
const formRef = ref()
const loading = ref(true)
const queryFormRef = ref()
const queryParams = reactive({
  pageNum: 1,
  pageSize: 10,
  username: null,
})
onMounted(()=>{
  getList()
})

const  callTypeText=(type)=> {
  switch (type) {
    case 1:
    case '1':
      return '呼入';
    case 2:
    case '2':
      return '呼出';
    case 3:
    case '3':
      return '未接';
    case 5:
    case '5':
      return '挂断';
    default:
      return type;
  }
}
// 表单重设
const reset = () => {
  form.value = {
    id: null,
    phoneNumber: null,
    callType: null,
    startTime: null,
    duration: null,
    contactName: null,
    createTime: null,
    userId: null,
    userName:null,
  }
  if (formRef.value) {
    formRef.value.resetFields()
  }
}
/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNum = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}
const getList = () => {
  loading.value = true
  const params = {
    pageNum: queryParams.pageNum,
    pageSize: queryParams.pageSize,
    userName: queryParams.username,
  }
  getCallPageList(params).then(response => {
    callList.value = response.data.records
    total.value = response.data.total
    loading.value = false
  })
}

/** 查看按钮操作 */
const handleView = (row) => {
  reset()
  form.value = {...row}
  open.value = true
  title.value = "查看圖片資訊"
  nextTick(() => {
    if (formRef.value) formRef.value.clearValidate && formRef.value.clearValidate()
  })
}
// 取消按钮
const cancel = () => {
  open.value = false
  reset()
}
</script>
<style scoped lang="scss">

</style>